import sql

class Categories:

    def __init__(self, parent):

        self.Parent = parent
        self.TableReady = False
        self.Data = []

        #Create the table if it doesn't exist
        self.Table = parent._meta.db_table + "_categories"

    def CheckForTable(self):

        if not self.TableReady:

            table_info = sql.query('pragma table_info(%s)'% self.Table)

            if not table_info:

                sql.execute('CREATE TABLE %s (id INTEGER PRIMARY KEY, name TEXT, parent INTEGER)' % (self.Table))

            self.TableReady = True

    def Add(self, name, parent):
        self.CheckForTable()

        sql.execute('INSERT INTO %s (name, parent) VALUES (?, ?)' % self.Table, name, parent)

        newCategory = Category(sql.last_insert_id(), name, parent, self)
        self.Data.append( newCategory )

        return newCategory

    def Delete(self, id):
        self.CheckForTable()

        sql.execute('DELETE FROM %s WHERE id = %s' % (self.Table, id))

        for x in self.Data:

            if x.id == id:
                break

        self.Data.remove(x)

    def ChangeName(self, id, newname):
        self.CheckForTable()

        newname = unicode(newname).encode('utf-8')

        sql.execute('UPDATE %s SET name=? WHERE id=?' % self.Table, newname, id)

        for x in self.Data:

            if x.id == id:
                x.Name = newname
                break

    def ChangeParent(self, id, newparent):
        self.CheckForTable()

        sql.execute('UPDATE %s SET parent=? WHERE id=?' % self.Table, newparent, id)

        for x in self.Data:

            if x.id == id:
                x.Parent = newparent
                break

    def Load(self):
        self.CheckForTable()

        cursor = sql.execute('SELECT * FROM %s ORDER BY id' % self.Table)

        results = []
        row = cursor.fetchone()
        while row:
            print row
            c = Category(row[0], row[1], row[2], self)

            results.append(c)

            row = cursor.fetchone()

        self.Data = results

class Category:

    def __init__(self, id, name, parent, categories):
        self.id = id
        self.Name = name
        self.Parent = parent

        self.Categories = categories

        self.TreeId = -1
