import sql



class Manager(object):
    def __init__(self, model):
        self.model = model

    def __getitem__(self, index):
        mq = self.all()
        return mq[index]

    def __iter__(self):
        return iter(self.all())

    def all(self):
        return ModelQuery(self.model)

    def get(self, id):
        mq = self.all().where(id=id)
        return mq[0]



class ModelQuery(object):
    def __init__(self, model):
        self.model = model

        self.__results = []
        self.__processed = False
        self.__wheres = []

    def __getitem__(self, index):
        if not self.__processed:
            self.process()

        return self.__results[index]

    def __iter__(self):
        if not self.__processed:
            self.process()

        return iter(self.__results)

    def where(self, **values):
        for key in values:
            self.__wheres.append((key, values[key]))

        return self



    def process(self):
        field_iter = enumerate(self.model._meta.fields)

        # Generate sql
        s = 'SELECT * FROM %s' % self.model._meta.db_table
        # Where statements
        if self.__wheres:
            where = []
            for key, value in self.__wheres:
                where.append("%s='%s'" % (key, value))

            s += ' WHERE ' + ' AND '.join(where)

        cursor = sql.execute(s + ' ORDER BY id')

        results = []
        row = cursor.fetchone()
        while row:
            m = self.model()

            for i, name in enumerate(self.model._meta.field_order):
                field = self.model._meta.fields[name]

                setattr(m, name, field.from_db(row[i]))

            results.append(m)

            row = cursor.fetchone()

        self.__results = results
        self.__processed = True
