import ika

from igl import Process
import windowskin



WINDOW_CLOSED, WINDOW_OPENING, WINDOW_OPEN, WINDOW_CLOSING = range(4)

class Window(Process):
    def __init__(self, x=0, y=0, w=0, h=0, heading=None):
        self.x = x
        self.y = y
        self.w = w
        self.h = h

        self.status = WINDOW_CLOSED

        self.windowskin = None

    def __closed(self):
        return self.status == WINDOW_CLOSED

    def __opened(self):
        return self.status == WINDOW_OPEN

    closed = property(__closed)
    opened = property(__opened)


    def start(self):
        self.status = WINDOW_OPEN



    def render(self):
        if self.opened:
            self.render_window(self.x, self.y, self.w, self.h)
            self.render_contents(self.x, self.y, self.w, self.h)

        else:
            pass

    def render_window(self, x, y, w, h):
        ika.Video.DrawRect(x, y, w, h, ika.RGB(255, 255, 255), True)

    def render_contents(self, x, y, w, h):
        pass

    def update(self):
        pass

    def control(self):
        pass
