import ika

# Returns a set of images from a canvas and a sequence of slice dimensions (x, y, w, h)
def get_slices(canvas, slices):
    images = []
    for x, y, w, h in slices:
        c = ika.Canvas(w, h)
        canvas.Blit(c, -x, -y)
        images.append(ika.Image(c))

    return images

# Slice image into rows and cols.
def get_grid(filename, rows, cols):
    image = ika.Canvas(filename)
    w = image.width / rows
    h = image.height / cols

    slices = []
    for y in xrange(cols):
        for x in xrange(rows):
            slices.append((x * w, y * h, w, h))

    return get_slices(image, slices)
