import ika

def Brensenham_line(p1,p2):
	"""Brensenham line algorithm"""
	x = p1[0]
	y = p1[1]
	x2 = p2[0]
	y2 = p2[1]
	
	steep = 0
	coords = []
	dx = abs(x2 - x)
	if (x2 - x) > 0: sx = 1
	else: sx = -1
	dy = abs(y2 - y)
	if (y2 - y) > 0: sy = 1
	else: sy = -1
	if dy > dx:
		steep = 1
		x,y = y,x
		dx,dy = dy,dx
		sx,sy = sy,sx
	d = (2 * dy) - dx
	for i in range(0,dx):
		if steep: coords.append((y,x))
		else: coords.append((x,y))
		while d >= 0:
			y = y + sy
			d = d - (2 * dx)
		x = x + sx
		d = d + (2 * dy)
	coords.append((x2,y2))
	return coords

class Point:
	
	def __init__(self, x, y):
		
		self.x = x
		self.y = y
		
		self.Degree = 0

def Generate():

	Points = []
	
	for x in range(6):
		Points.append(Point(ika.Random(0,15), ika.Random(0,14)))
		
	for x in Points:
		for y in Points:
			if x.Degree != 2 and y.Degree < 2:
				if not CheckLineObs(x, y):
					if x.x != y.x or y.y != x.y:
						DrawLine(x,y)
						x.Degree += 1
						y.Degree += 1
						
	return Points


def GenerateMap():
	
	Restart = True
	
	while Restart == True:
		for x in range(15):
			for y in range(15):
				ika.Map.SetTile(x,y,0,0)
		
		Points = Generate()
		
		Restart = False

		for x in Points:
			#print "%s-%s d%s" % (x.x,x.y,x.Degree)
			#ika.Map.SetTile(x.x, x.y, 0, 2)
			
			if x.Degree != 2:
				#ika.Map.SetTile(x.x, x.y, 0, 2)
				Restart = True
			
	
def DrawLine(p1, p2):
	
	p1 = [p1.x, p1.y]
	p2 = [p2.x, p2.y]
	
	for x,y in Brensenham_line(p1, p2):
		ika.Map.SetTile(x,y,0,1)	
	
def CheckLineObs(p1,p2):
	
	p1 = [p1.x, p1.y]
	p2 = [p2.x, p2.y]	
	
	obsC = 0
	
	for x,y in Brensenham_line(p1, p2):
		if ika.Map.GetTile(x,y,0) == 1:
			obsC+=1
			
	if obsC > 1:
		return True
	else:
		return False
			
	