import engine
import utility
import ika

Offsets = [0,0,0,0,0,0,0,0,1,2,3,4,5,7,9,10,11,11,11,11,11,11,11,11,10,8,6,4,2,1,2,3,4,5,6,7,8,7,6,5,4,3,2,1,2,3,4,5,5,5,4,3,2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0] 

Effects = []

def Update():
	
	#Update containers
	
	for effect in Effects:
		effect.Update()
	
	for i,effect in enumerate(Effects):
		if hasattr(effect, "Dead") and effect.Dead:
			Effects.pop(i)
	
def Render(): 
	
	#Render containers
	for effect in Effects:
		effect.Render()

class DamageNumber:
	
	def __init__(self, x,y, number):
		
		self.Number = str(number)
		self.Position = 0
		
		self.x=x
		self.y=y
			
	
	def Render(self):
		
		for i,dmg in enumerate(self.Number):
			n = self.Position+(i*4)
			if n > len(Offsets)-1:
				n = len(Offsets)-1
				
			xy = utility.MapToScreen([self.x,self.y])
			
			#NOTE: Use images later to add a fade effect.
			engine.Fonts["Damage"].Print(xy[0]+(i*8),xy[1]-Offsets[n],dmg)
		
	def Update(self):
		
		self.Position += 1
		
		if self.Position-5 >= len(Offsets)-1:
			self.Dead = 1