import ika
import manager
import window
import entity

import character
import teleport
import fps
import queue
import direction
from tilecollisions import *

class Map:
	
	Name = ""
	Entities = []
	
last_fps = 0
Maps = [ ]
MapObjects = [ ]
CurrentMap = ""

Queue = queue.Queue()

Fonts =	 {

			"Red" : ika.Font("main.fnt"),
			"Blue" : ika.Font("main.fnt"),
			"Order" : ika.Font("heading.fnt"),
			"Interface" : ika.Font("main.fnt"),

		 }
		
Windows = {
			"Menu" : window.Window("wtest"),
			"Select" : window.CustomBackgroundWindow("wtest",'wselect')
		}
		
Sounds = {

		}
		
Music = {
		"Desert" : "sounds\\every.ogg",
		"Cave" : "sounds\\ripped.it",
		"Battle": "sounds\\mag_enc2.it"

		}
		
Images = {

		"Pointer" : ika.Image("images\\pointer.png")

		}
		
Obs = [
		#Main Cliff
		Tile(42,1),
		#Cliff sides
		Tile(44,1),Tile(45,1),Tile(46,1),Tile(47,1),
		Tile(2,1),Tile(50,1),Tile(54,1),Tile(57,1),Tile(58,1),Tile(61,1),Tile(62,1),Tile(70,1), Tile(20,0,u=1),
		Tile(36,0,ladder=1),
		Tile(48,0,l=1), Tile(49,0,r=1), Tile(52,0,u=1), Tile(53,0,d=1),
		#Chests
		Tile(88,1), Tile(89,1),
		#Cave walls
		Tile(74,1), Tile(75,1),
		Tile(78,1), Tile(79,1),
		#Cave sides
		Tile(76,0,l=1), Tile(80,0,u=1), Tile(82,0,r=1), Tile(83,0,d=1)
	]

m = ""		
mname = ""

def GetObs(tile):
	
	for x in Obs:
		if x.Number == tile:
			return x
			
	return None
		
def PlaySound(snd):		
	
	Sounds[snd].Play()

def PlayMusic(mus):
	global m, mname
	if mus != mname:
		mname = mus
		m = ika.Music(Music[mus])
		m.Play()
		m.loop = 1
		
def GGetPlayer():
	global maps 
	for map in Maps:
		if map.Name == CurrentMap:	
			for entity in map.Entities:
				if isinstance(entity, Player):
					return entity

def ChangeMap(map,x=-1,y=-1):
	global CurrentMap, Maps, MapObjects
	dir = "Up"
	if x == -1:
		x = map[1]
		y = map[2]
		dir = map[3]
		map = map[0]
		
	
	CurrentMap = map
	Maps[0].Name = map
	
	#for entity in Maps[0].Entities:
		
		#if entity != GGetPlayer():
		
		#	entity.Dead= 1
			
	#for obj in MapObjects:
		
	#	if isinstance(obj, ColorMap):
			
	#		obj.Dead = 1
	
	if GGetPlayer() != None:
		#chara = GGetPlayer().Character	
		p = GGetPlayer()
	else:
		p = Player(32*x,32*y)
		Maps[0].Entities.append( p)

	ika.Map.Switch(map)
	ika.Map.module.OnEnter()

	teleport.Teleports =  [ ]
	#spawner.ind = 0
	#Maps[0].Entities = []
	#p = Player(32*x, 32*y, chara) 
	p.Sprite.Direction = direction.direction[dir]
	p.Sprite.x = 32*x
	p.Sprite.y = 32*y
	
	#MapObjects.append( ColorMap(ika.Map.GetLayerProperties(0)[1], ika.Map.GetLayerProperties(0)[2]) )

	mw = ika.Map.GetLayerProperties(0)[1]
	mh = ika.Map.GetLayerProperties(0)[2]	

	#for x in range(mw):
	#	for y in range(mh):
	#		if not ika.Map.GetTile(x,y,0) % 2:
	#			ika.Map.SetTile(x,y,0, ika.Map.GetTile(x,y,0)+1)	

	#GGetPlayer().ClearMap()
	
	

	#spawner.Run()
	
def ClearSpawner():
	
	spawner.Clear()
	
def UpdateEntities():
	
	global Maps, CurrentMap
	
	for map in Maps:
		for i, entity in enumerate(map.Entities):
			
			if hasattr(entity,"Dead") and entity.Dead:
				
				map.Entities.pop(i)
				
		
		for entity in map.Entities:
			
			entity.Update()
			
	#print str(map.Entities)
			
def UpdateObjects():
	
	global MapObjects
	
	Queue.Update()
	
	for i, obj in enumerate(MapObjects):
		
		if hasattr(obj, "Dead") and obj.Dead:
			
			MapObjects.pop(i)
			break
	
	for obj in MapObjects:
		
		obj.Update() 
	
	
def RenderObjects():
	
	for obj in MapObjects:
		
		obj.Render() 	
	
			
def AddEntity(entity):
	global CurrentMap, Maps
	
	for x in Maps:
		if x.Name == CurrentMap:
			x.Entities.append(entity)
			
def YCompare(x,y):

	if isinstance(x, Player):
		return 10
	if isinstance(y, Player):
		return -10

	return int( (x.Sprite.y+x.Sprite.HotY) - (y.Sprite.y+y.Sprite.HotY) )
						
def MainLoop():
	last_update = 0
	
	FPS = fps.FPSManager(60)
		
	while 1:
		if ika.GetTime() >= last_update:
			last_update = ika.GetTime()            

			global last_fps

			if last_fps != ika.GetFrameRate():
				#ika.SetCaption( "Hydration 2 (%s)" % (ika.GetFrameRate()) )
				ika.SetCaption("Hydration 2: Oasis (Demo)")
				last_fps = ika.GetFrameRate()

			ika.Input.Update()
			manager.ExecuteUpdateList()
			#ika.ProcessEntities()

			last_update = ika.GetTime()+1
			
		FPS.render(MainRender)

def MainRender():			
	for i in range(ika.Map.layercount):
		ika.Render(i)
		
		#Probably a more efficent way to do this than searching the array over and over, but I won't 
		#worry about it until it hurts performance.
		global Maps, CurrentMap
		
		for map in Maps:
			if map.Name == CurrentMap:
				map.Entities.sort(YCompare)
				for entity in map.Entities:
					if entity.Sprite.Layer == i:
						entity.Render()
		

	manager.ExecuteRenderList()
	
	GGetPlayer().RenderBar()
	
	Queue.Render()

from player import Player

#import statmenu
#def StatMenu():
#	MapObjects.append(statmenu.Create(self.nextLevels*3))