import interface
import engine
import ika

import itemmenu
import equipmenu

class ItemC(interface.MenuChoice):
	
	def __init__(self):
		self.Name = "Items"
		self.Desc = ""
		self.Used = 0

	def Execute(self, parent):
		if len(engine.GGetPlayer().Items) > 0 and self.Used == 0:
			engine.MapObjects.append(itemmenu.Create())
			parent.Close()
			self.Used = 1
		
class EquipC(interface.MenuChoice):
	
	def __init__(self):
		self.Name = "Equipment"
		self.Desc = ""
		self.Used = 0

	def Execute(self, parent):
		if self.Used == 0:
			engine.MapObjects.append(equipmenu.Create())
			parent.Close()
			self.Used = 1
		
class ReturnC(interface.MenuChoice):
	
	def __init__(self):
		self.Name = "Return"
		self.Desc = ""

	def Execute(self, parent):
		p = engine.GGetPlayer()
		
		p.UnFreeze()

		parent.Close()
		
class QuitC(interface.MenuChoice):
	
	def __init__(self):
		self.Name = "Quit"
		self.Desc = ""

	def Execute(self, parent):
		ika.Exit()
		
class ItemMenuInput:
	
	SelectButtons = ["guard","skill_a", "skill_b", "skill_c"]
	
	def OnSelect(self, parent, choice, button):
		
		if button == "guard":
			choice.Execute(parent)
		else:
			choice.Finish()
			parent.Close()	
			engine.MapObjects.append(Create())
			parent.Close()			
		
class EquipMenuInput:
	
	SelectButtons = ["guard","skill_a", "skill_b", "skill_c"]
	
	def OnSelect(self, parent, choice, button):
		
		if button == "guard":
			choice.Execute(parent)
		else:
			engine.MapObjects.append(Create())
			parent.Close()

def Create():

	p = engine.GGetPlayer()

	menu = interface.Menu(50, 50, [ItemC(),EquipC(),ReturnC(),QuitC()], interface.ChoiceMenuInput, hideDesc=True)
	menu.Plugins = [interface.StatWindow(menu,p)]

	p.SetState(p.StateFreeze())
	
	return menu