import engine
from controls import *
import windowscript
from iinput import *
from ichoice import *

class Menu:
	
	Color = ika.RGB(255,255,255,255)
	
	def __init__(self, x,y, choices, input,  extraW=0, plugins=[],hideDesc=False):
		
		self.WindowScript = windowscript.WindowScript(self)
		
		self.Plugins = plugins
		
		self.x = x
		self.y = y
		self.w = 0
		self.h = 0
		
		self.Position = 0
		self.Page = 0
		self.VisualPosition = 0
		
		self.Input = input()
		self.Choices = choices
		self.Dying = 0
		
		self.Timer = 10
		
		self.HideDesc = hideDesc
		
		self.DWindow = DescriptionWindow()
		
		self.MPointer = ika.Image("images\\MenuPointa2.png")
		
		w = 0
		
		for o in self.Choices:
			s = engine.Fonts["Interface"].StringWidth(o.Name)
			if  s > w:
				w = s
				
		w += 10+extraW
		
		if len(self.Choices) < 10:
			h = engine.Fonts["Interface"].height*(len(self.Choices))
		else:
			h =  engine.Fonts["Interface"].height*10
		
		self.WindowScript.SetScript("wh%(w)s,%(h)s,1,5" % { "w" : w, "h" : h } )
	
	def Close(self):
		
		self.DWindow.Close()
		for x in self.Plugins:
			x.Close()
		self.Dying = 1
		
		self.WindowScript.SetScript("height0,1,6 width0,1,6" )
		
	
	def Render(self):
		
		engine.Windows["Menu"].Blit(self.x, self.y, self.w, self.h,self.Color)
		
		ika.Video.ClipScreen(self.x, self.y, self.x+self.w, self.y+self.h)
		
		n = 0
		for x in self.Choices:
			if n > (self.Page*10)-1 and n < ((self.Page+1)*10):
				p = n - (self.Page*10)
				x.Render(self.x+10,self.y+(p*engine.Fonts["Interface"].height) )
			n += 1
		
		#engine.Fonts["Interface"].Print(self.x,self.y+(self.VisualPosition*engine.Fonts["Interface"].height), ">")
		self.MPointer.Blit(self.x, self.y+(self.VisualPosition*engine.Fonts["Interface"].height))
		
		ika.Video.ClipScreen()
		
		if self.HideDesc == False:
			self.DWindow.Render()
		
		for x in self.Plugins:
			x.Render()
		
	def CalcPositions(self):

		self.VisualPosition = self.Position
		self.Page = 0
		while self.VisualPosition >= 10:
			self.VisualPosition-=10
			self.Page+=1
	
	def Update(self):
		if not self.Dying:
			engine.GGetPlayer().Freeze()
		else:
			engine.GGetPlayer().UnFreeze()
		
		self.WindowScript.Update()
		
		position, pressed= GetButtons()
		
		if (self.Timer < 8):
			self.Timer += 1
			
		if "up" in position and self.Timer >= 8:
			if self.Position > 0:
				self.Position -= 1
				self.Timer = 0
		
		elif "down" in position and self.Timer >= 8:
			if self.Position < len(self.Choices)-1:
				self.Position+= 1
				
				self.Timer = 0
			
		else:
			for b in pressed:
				#ika.Exit(str(self.Input.SelectButtons))
				if b in self.Input.SelectButtons:
					
					self.Input.OnSelect(self, self.Choices[self.Position],b)
					break 
		
		for x in self.Choices:
			x.Update(self)
		
		self.CalcPositions()
		
		self.DWindow.SetText(self.Choices[self.Position].Desc)
		self.DWindow.Update()
		
		for x in self.Plugins:
			x.Update(self.Choices[self.Position])
		
		if self.Dying:
			if self.WindowScript.Finished:
				self.Dead = 1
		
#------------------------------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------------------------------
#------------------------------------------------------------------------------------------------------------------------------------

class SkillList:
	
	def __init__(self, parent, player):
		
		self.Color = Color = ika.RGB(255,255,255,255)
		
		self.Player = player
		self.Parent = parent
		
		self.WindowScript = windowscript.WindowScript(self)
		
		self.x = parent.x+100
		self.y = parent.y
		
		self.w = 0
		self.h = 10
		
		w = 90
		h = 30
		
		self.Dying = 0
		self.Dead = 0

		self.WindowScript.SetScript("wh%(w)s,%(h)s,1,5" % { "w" : w, "h" : h } )
			
	def Render(self):
		
		engine.Windows["Menu"].Blit(self.x, self.y, self.w, self.h,self.Color)
		
		ika.Video.ClipScreen(self.x, self.y, self.x+self.w, self.y+self.h)
		
		engine.Fonts["Order"].Print(self.x, self.y+1, "A")
		engine.Fonts["Order"].Print(self.x, self.y+11, "S")
		engine.Fonts["Order"].Print(self.x, self.y+21, "D")

		if self.Player.Character.Skills[2] is not None:
			engine.Fonts["Interface"].Print(self.x+10,self.y+1,self.Player.Character.Skills[2].Name )
			
		if self.Player.Character.Skills[3] is not None:
			engine.Fonts["Interface"].Print(self.x+10,self.y+11,self.Player.Character.Skills[3].Name )
			
		if self.Player.Character.Skills[4] is not None:
			engine.Fonts["Interface"].Print(self.x+10,self.y+21,self.Player.Character.Skills[4].Name )

		ika.Video.ClipScreen()
		
	def Update(self, curChoice):
		
		self.WindowScript.Update()
				
		if self.Dying:
			if self.WindowScript.Finished:
				self.Dead = 1
				
	def Close(self):
		
		self.Dying = 1
		
		self.WindowScript.SetScript("height0,1,1 width0,1,16" )

class EquippedWindow:
	
	def __init__(self, parent, player):
		
		self.Color = Color = ika.RGB(255,255,255,255)
		
		self.Player = player
		self.Sword = self.Player.Sword
		self.Armor = self.Player.Armor
		
		self.WindowScript = windowscript.WindowScript(self)
		
		self.x = parent.x+150
		self.y = parent.y
		
		self.w = 0
		self.h = 0
		
		w = 90
		h = 50
		
		self.Dying = 0
		self.Dead = 0
		self.OldChoice = 0
		self.Stats = []

		self.WindowScript.SetScript("wh%(w)s,%(h)s,1,5" % { "w" : w, "h" : h } )
			
	def Render(self):
		
		engine.Windows["Menu"].Blit(self.x, self.y, self.w, self.h,self.Color)
		
		ika.Video.ClipScreen(self.x, self.y, self.x+self.w, self.y+self.h)

		engine.Fonts["Interface"].Print(self.x,self.y+1,"Vitality: %s %s %s" % self.Stats[0] )
		engine.Fonts["Interface"].Print(self.x,self.y+11,"Strength: %s %s %s" % self.Stats[1] )
		engine.Fonts["Interface"].Print(self.x,self.y+21,"Defense: %s %s %s" % self.Stats[2] )
		engine.Fonts["Interface"].Print(self.x,self.y+31,"Luck: %s %s %s" % self.Stats[3] )
		engine.Fonts["Interface"].Print(self.x,self.y+41,"Speed: %s %s %s" % self.Stats[4] )
			
		ika.Video.ClipScreen()
		
	def Update(self, curChoice):
		
		s = ["Vitality", "Strength", "Defense", "Luck", "Speed"]
		
		if curChoice != self.OldChoice:
			self.Stats = []
			for x in s:
				stat = getattr(self.Player.Character, x)
				if curChoice.Item.Type == 0: #sword
					oldI = getattr(self.Sword, x)
				else:
					oldI = getattr(self.Armor, x)
				newI = getattr(curChoice.Item, x)
				
				difference = newI-oldI
				
				if difference < 0:
					sign = "#[FF0000FF]-"
				else:
					sign = "#[FF00FF1D]+"

				self.Stats.append( (stat,sign,abs(difference)) )

		self.WindowScript.Update()
				
		if self.Sword.id != self.Player.Sword.id:
			for x in s:
				oldI = getattr(self.Player.Sword, x)
				newI = getattr(self.Sword, x)
				
				setattr(self.Player.Character, x, getattr(self.Player.Character, x)+(newI-oldI) )
				
				
			self.Player.Sword = self.Sword
				
		elif self.Armor.id != self.Player.Armor.id:
			for x in s:
				oldI = getattr(self.Player.Armor, x)
				newI = getattr(self.Armor, x)
				
				setattr(self.Player.Character, x, getattr(self.Player.Character, x)+(newI-oldI) )
				
			self.Player.Armor = self.Armor
				
		if self.Dying:
			if self.WindowScript.Finished:
				self.Dead = 1
				
	def Close(self):
		
		self.Dying = 1
		
		self.WindowScript.SetScript("height0,1,7 width0,1,7" )
		
class StatWindow:
	
	def __init__(self, parent, player):
		
		self.Color = Color = ika.RGB(255,255,255,255)
		
		self.Player = player
		
		self.WindowScript = windowscript.WindowScript(self)
		
		self.x = parent.x+150
		self.y = parent.y
		
		self.w = 0
		self.h = 0
		
		w = 90
		h = 50
		
		self.Dying = 0
		self.Dead = 0
		self.OldChoice = 0

		self.WindowScript.SetScript("wh%(w)s,%(h)s,1,5" % { "w" : w, "h" : h } )
			
	def Render(self):
		
		engine.Windows["Menu"].Blit(self.x, self.y, self.w, self.h,self.Color)
		
		ika.Video.ClipScreen(self.x, self.y, self.x+self.w, self.y+self.h)

		engine.Fonts["Interface"].Print(self.x,self.y+1,"Vitality: %s" % self.Player.Character.Vitality)
		engine.Fonts["Interface"].Print(self.x,self.y+11,"Strength: %s" % self.Player.Character.Strength)
		engine.Fonts["Interface"].Print(self.x,self.y+21,"Defense: %s" % self.Player.Character.Defense )
		engine.Fonts["Interface"].Print(self.x,self.y+31,"Luck: %s" % self.Player.Character.Luck )
		engine.Fonts["Interface"].Print(self.x,self.y+41,"Speed: %s" % self.Player.Character.Speed )
			
		ika.Video.ClipScreen()
		
	def Update(self, curChoice):

		self.WindowScript.Update()

		if self.Dying:
			if self.WindowScript.Finished:
				self.Dead = 1
				
	def Close(self):
		
		self.Dying = 1
		
		self.WindowScript.SetScript("height0,1,7 width0,1,7" )

class BonusPointWindow:
	
	def __init__(self, parent, points):
		
		self.Color = Color = ika.RGB(255,255,255,255)
		
		self.Points = points
		
		self.WindowScript = windowscript.WindowScript(self)
		
		self.x = parent.x
		self.y = parent.y-17
		
		self.w = 0
		self.h = 10
		
		w = 50
		h = 10
		
		self.Dying = 0
		self.Dead = 0

		self.WindowScript.SetScript("wh%(w)s,%(h)s,1,5" % { "w" : w, "h" : h } )
			
	def Render(self):
		
		engine.Windows["Menu"].Blit(self.x, self.y, self.w, self.h,self.Color)
		
		ika.Video.ClipScreen(self.x, self.y, self.x+self.w, self.y+self.h)

		engine.Fonts["Interface"].Print(self.x,self.y+1,"Points: %s" % (self.Points) )
			
		ika.Video.ClipScreen()
		
	def Update(self, curChoice):
		
		self.WindowScript.Update()
				
		if self.Dying:
			if self.WindowScript.Finished:
				self.Dead = 1
				
	def Close(self):
		
		self.Dying = 1
		
		self.WindowScript.SetScript("height0,1,1 width0,1,16" )
		
class DescriptionWindow:
	
	def __init__(self):
		
		self.Color = Color = ika.RGB(255,255,255,255)
		
		self.WindowScript = windowscript.WindowScript(self)
		
		self.x = 15
		self.y = 210
		self.w = 0
		self.h = 20
		
		self.fw = 290
		w = 290
		h = 22
		
		self.Text = ""
		
		self.Lines = [""]
		self.Scroll = [0]
		
		self.WindowScript.SetScript("wh%(w)s,%(h)s,1,5" % { "w" : w, "h" : h } )
			
		self.Dying = 0
		
	def SetText(self, text):
		if text != self.Text:
			self.Text = text
			self.Lines = [""]
			self.Scroll = [0]			
			
			i = 0
			new = 1
			for x in text.split(" "):
				if engine.Fonts["Interface"].StringWidth(self.Lines[i]+x) < self.fw-10 and x != "\n":
					self.Lines [i]= self.Lines[i]+" "+x
					if new:
						self.Lines[i] = x
						new = 0
				else:
					i+=1
					self.Lines.append(x)
					self.Scroll.append(0)
		
	def Render(self):
		
		engine.Windows["Menu"].Blit(self.x, self.y, self.w, self.h,self.Color)
		
		ika.Video.ClipScreen(self.x, self.y, self.x+self.w, self.y+self.h)
		
		for i, line in enumerate(self.Lines):
			
			engine.Fonts["Interface"].Print(self.x,self.y+(i*engine.Fonts["Interface"].height+1), line[ 0:self.Scroll[i] ] )
				
		for i, line in enumerate(self.Lines):
			
			if self.Scroll[i] < len(line):
				self.Scroll[i]+=1
				break
			
		ika.Video.ClipScreen()
		
	def Update(self):
		
		self.WindowScript.Update()
			
		if self.Scroll < len(self.Text):
			a = 0
			while a < 3 and self.Scroll < len(self.Text):
				self.Scroll+=1
				a+=1
				
		if self.Dying:
			if self.WindowScript.Finished:
				self.Dead = 1
				
	def Close(self):
		
		self.Dying = 1
		
		self.WindowScript.SetScript("height0,1,1 width0,1,16" )
