import ika
import transition

class Function:
	
	def __init__(self, func, args=None):
		
		self.Func = func
		self.Blocking = 0
		self.Dead = 0
		self.Args = args
		
	def Update(self):
		if self.Args is not None:
			self.Func(self.Args)
		else:
			self.Func()
		self.Dead = 1

class Queue:
	"""
		Queue 
		
		Handles adding a list of objects to be processed in
		a sequential and semi-sequential order. 
		
		Any object added to a queue object is only expected
		to have a Dead property to inform it when it's finished.
	
	"""
	
	def __init__(self):
		
		self.Objects = [ ]
		#self.Add( transition.TransitionTo(ika.RGB(255,255,255) ) )
	
	def Add(self, object, blocking=True):
		
		if not hasattr(object, "Dead"):
			print "Object doesn't have dead property."
			return 0
		if not hasattr(object, "Blocking"):
			object.Blocking = blocking
		
		self.Objects.append(object)
		
	def Update(self):
		
		for x in self.Objects:
			#ika.Exit("A")
			x.Update()
			
			if x.Blocking: 
				break
			
		for i, x in enumerate(self.Objects):	
			if x.Dead:
				self.Objects.pop(i)
				self.Update()
		
	def Render(self):
		
		for x in self.Objects:
			if x.Layer == 0:
				x.Render()
			
			if x.Blocking: 
				break
				
		for x in self.Objects:
			if x.Layer == 1:
				x.Render()
			
			if x.Blocking: 
				break
