import ika 

Teleports = [ ]
Black = ika.Image("images\\black.png")

import player
import engine

class FadeIn:
	
	Color = ika.RGB(255,255,255,255)
	
	def Update(self):
		
		o = 0
		
		while o <= 6 and not hasattr(self,"Dead"):
			
		
			r,g,b,a = ika.GetRGB(self.Color)
			
			a -= 1
			
			self.Color = ika.RGB(r,g,b,a)
			
			if a <= 0:
				self.Dead = 1
				if player.GetPlayer().LevelOn:
					player.GetPlayer().SetState(player.GetPlayer().StateStand())
				
			o += 1
		
	def Render(self):
		
		ika.Video.TintBlit(Black, 0, 0, self.Color)
		
class FadeOut:
	
	Alpha = 0
	Color = ika.RGB(255,255,255,0)
	
	def __init__(self, map, nx, ny):
		self.nx = nx
		self.ny = ny
		self.Map = map
		
		player.GetPlayer().SetState(player.GetPlayer().StateLevelUp())
	
	def Update(self):
		
		o = 0
		
		while o <= 6 and not hasattr(self,"Dead"):		
		
			r,g,b,a = ika.GetRGB(self.Color)
			
			a += 1
			
			self.Color = ika.RGB(r,g,b,a)
			
			if a >= 255:
				engine.ChangeMap(self.Map, self.nx, self.ny)
				engine.MapObjects.append(FadeIn())
				self.Dead = 1
				
			o += 1
		
	def Render(self):
		
		ika.Video.TintBlit(Black, 0, 0, self.Color)

class Teleporter:
	
	def __init__(self, cX, cY, map, nX, nY):
		
		self.cx = cX
		self.cy = cY
		self.Map = map
		self.nx = nX
		self.ny = nY
		
class TeleportScan:
	
	def Update(self):
		
		for t in Teleports:
			
			p = player.GetPlayer() 
			
			if p.Sprite.x/16 == t.cx and p.Sprite.y/16 == t.cy:
				for x in engine.MapObjects:
					if isinstance(x, FadeOut):
						return 0
				engine.MapObjects.append(FadeOut("maps\\"+t.Map+".ika-map", t.nx, t.ny))
				engine.PlaySound("walk")
				
				if t.Map == "18":
					engine.PlayMusic("Boss")
				elif engine.mname == "Boss" and t.Map != "19":
					engine.PlayMusic("Map")
				
				#engine.ChangeMap("maps\\"+t.Map+".ika-map", t.nx, t.ny)
		
	def Render(self):
		
		pass

def SetTeleport(cX, cY, map, nX, nY):
	
	global Teleports
	
	Teleports.append(Teleporter(cX, cY, map, nX, nY))
	
