
import ika
import engine
from controls import *
import battle

class TextBox:
	
	def __init__(self, text):
		
		self.x = 10
		self.y = 180
		self.w = 300
		self.h = 50
		
		self.Lines = [""]
		self.Scroll = [0]
		
		self.First = 1
		
		self.Color = ika.RGB(0,0,0)
		
		i = 0
		new = 1
		for x in text.split(" "):
			if engine.Fonts["Interface"].StringWidth(self.Lines[i]+x) < self.w-10 and x != "\n":
				self.Lines [i]= self.Lines[i]+" "+x
				if new:
					self.Lines[i] = x
					new = 0
			else:
				i+=1
				self.Lines.append(x)
				self.Scroll.append(0)
				
		self.Dead = 0
		self.Layer = 0
		
	def Render(self):
		
		engine.Windows["Menu"].Blit(self.x, self.y, self.w, self.h,self.Color)
		
		ika.Video.ClipScreen(self.x, self.y, self.x+self.w, self.y+self.h)
		
		for i, line in enumerate(self.Lines):
			
			engine.Fonts["Interface"].Print(self.x,self.y+(i*engine.Fonts["Interface"].height+1), line[ 0:self.Scroll[i] ] )
				
		for i, line in enumerate(self.Lines):
			
			if self.Scroll[i] < len(line):
				self.Scroll[i]+=1
				break
			
		ika.Video.ClipScreen()
		
	def Update(self):
		
		if self.First:
			engine.GGetPlayer().Freeze()
			self.First = 0
		
		position, pressed= GetButtons()
		
		if "guard" in pressed:
			self.Dead = 1
			engine.GGetPlayer().UnFreeze()
		if not self.Dead:
			engine.GGetPlayer().Freeze()
			#battle.StartCombat(0)