import ika

class Stripe:
	
	def __init__(self, y, h, speedM,speedA, color, direction):
		
		self.y = y
		self.h = h
		
		if direction >= 0:
			self.w = 0
			self.Alpha = 0
		else:
			self.w = 600
			self.Alpha = 255
		
		self.SpeedM = speedM
		self.SpeedA = speedA
		self.Color = color
		self.Direction = direction
		
		self.Dead = 0
	
	def Render(self):

		ika.Video.DrawRect(0,self.y,self.w,self.h+self.y,self.Color,1)
		
	def Update(self):
		
		(r,g,b,a) = ika.GetRGB(self.Color)
		self.Color = ika.RGB(r,g,b,self.Alpha)
		
		self.w += self.SpeedM*self.Direction
		
		if self.Direction >= 0:
			if self.Alpha < 255:
				self.Alpha += self.SpeedA
			if self.Alpha > 255:
				self.Alpha = 255
		else:
			if self.Alpha > 0:
				self.Alpha -= self.SpeedA
			if self.Alpha < 0:
				self.Alpha = 0

		if self.Direction >= 0:
			if self.w >= 600 and self.Alpha == 255:
				self.Dead = 1
				
		elif self.Direction < 0:
			pass
			if self.w <= -200 and self.Alpha == 0:
				self.Dead = 1
		
class TransitionTo:
	
	Direction = 1
	
	def __init__(self, color, speed=2):
		
		h = 0
		self.Stripes = []
		
		while h < 300:
			nh = ika.Random(5,15)
			
			self.Stripes.append( Stripe(h,nh,ika.Random(10,18),ika.Random(4,6),color, self.Direction) )
			
			h+= nh+1
			
		self.Dead = False
		self.Layer = 1
		
	def Update(self):
		
		for x in self.Stripes:
			x.Update()
			
		n = 1
		for x in self.Stripes:
			if x.Dead == False:
				n = 0
		if n:
			self.Dead = 1
		
	def Render(self):
		
		for x in self.Stripes:
			x.Render()

		
class TransitionFrom(TransitionTo):
	
	Direction = -1
		