import ika
import textbox
import engine

class Treasure:
	
	def __init__(self,x,y,probability,area):
		self.x = x
		self.y = y
		self.Opened = 0
		self.Probability = probability
		self.Area = area

		self.ChooseItem()

	def ChooseItem(self):
		#Items for an are categorized into sets of 1-4, 1 being common and 4 being rare.
		#The set is chosen by randomizing from 0 to 100.
		#0-39: rank 1
		#40-69: rank 2
		#70-89: rank 3
		#90-100: rank 4
		#Probability 1's are randomized from 0 to 80
		#Probability 2's are randomized from 20 to 100
		#Probability 3's are randomized from 50 to 100
		#Probability 4's are randomized from 80 to 100
		
		if self.Area == "1":
			Set = {
					1: [(1,'i'), (5,'i'), (12,'i'), (13,'i'), (14,'i')],
					2: [(2,'e'), (18, 'e'), (4,'e'), (8, 'e') ],
					3: [(9, 'e'), (5,'e'), (2, 'i'), (5,'i')],
					4: [(6,'e')]
				}
		elif self.Area == "2":
			Set = {
					1: [(1,'i'), (5,'i'), (12,'i'), (13,'i'), (14,'i')],
					2: [(9, 'e'), (5,'e'), (2, 'i'), (5,'i')],
					3: [(11,'e'), (12, 'e'), (7, 'e'), (15,'e')],
					4: [(10,'e'), (9, 'e'), (9, 'i'), (10, 'i')]
				}
		elif self.Area[0:2] == "c1":
			Set = {
					1: [(1,'i'), (5,'i'), (12,'i'), (13,'i'), (14,'i'),(2,'e'), (18, 'e')],
					2: [(2,'e'), (18, 'e'), (4,'e'), (8, 'e'), (9, 'e'), (5,'e'), (2, 'i'), (5,'i')],
					3: [(9, 'e'), (5,'e'), (2, 'i'), (5,'i'), (6,'e') ],
					4: [(7,'e'), (10,'e'), (11, 'i')]
				}		

		elif self.Area[0:2] == "c2":
			Set = {
					1: [(11,'e'), (12, 'e'), (7, 'e'), (15,'e'), (10,'e'), (9, 'e')],
					2: [(9,'e'), (10,'e'), (8,'e')],
					3: [(14,'e'), (16,'e'), (2, 'i')],
					4: [(14,'e'), (13, 'e'), (16, 'e'), (17,'e')]
				}		
		
		if self.Probability == 0:
			n = ika.Random(0,80)
		elif self.Probability == 1:
			n = ika.Random(20,100)
		elif self.Probability == 2:
			n = ika.Random(50,100)
		elif self.Probability == 3:
			n = ika.Random(80,100)
			
		if n in range(0,40):
			self.Item = Set[1][ika.Random(0,len(Set[1]))]
		if n in range(40,70):
			self.Item = Set[2][ika.Random(0,len(Set[2]))]
		if n in range(70,90):
			self.Item = Set[3][ika.Random(0,len(Set[3]))]
		if n in range(90,100):
			self.Item = Set[4][ika.Random(0,len(Set[4]))]
		

	def Open(self, player):
		
		if self.Opened == 0:
			
			if self.Item[1] == 'i':
			
				engine.Queue.Add( textbox.TextBox("Marcus found %s!" % player.AddItem(self.Item[0])))
			else:
				engine.Queue.Add( textbox.TextBox("Marcus found %s!" % player.AddEquip(self.Item[0])))

			self.Opened = 1
			self.UpdateTile()

	def UpdateTile(self):
		
		if self.Opened == 0:
			
			ika.Map.SetTile(self.x,self.y,3,88)
		else:
			
			ika.Map.SetTile(self.x,self.y,3,89)