import ika
import windowscript

class Window:
	
	
	def __init__(self, file):
		
		self.Images = { }
		self.Load(file)

	
	def Load(self, file):
		
		#Corners
		
		for x in ["ur", "ul", "dr", "dl"]:
			self.Images["corner_"+x] = ika.Image("images\\"+file+"_corner_"+x+".png")
		
		#Sides
		for x in ["u", "d", "l", "r"]:
			self.Images["side_"+x] = ika.Image("images\\"+file+"_side_"+x+".png")
			
		self.Images["background"] = ika.Image("images\\"+file+"_bg.png")
			
	def Blit(self, x, y, w, h, color):
		
		x -= 16
		y -= 16
		w += 16
		h += 16
		
		TotalHeight = 0
		TotalWidth = 0
		Images = self.Images
		
		Images["corner_ul"].Blit(x, y)
		
		Images["corner_dl"].Blit(x,y+h)
		
		Images["corner_ur"].Blit(x+w,y)
		
		Images["corner_dr"].Blit(x+w,y+h)
		
		ika.Video.TileBlit(Images["side_u"],x+Images["corner_ul"].width, y, w-Images["corner_ul"].width, Images["side_u"].height)
		
		ika.Video.TileBlit(Images["side_d"],x+Images["corner_ul"].width, y+h, w-Images["corner_ul"].width, Images["side_d"].height)
		
		ika.Video.TileBlit(Images["side_l"],x, y+Images["corner_ul"].height, Images["side_u"].width, h-Images["corner_ul"].height)
		
		ika.Video.TileBlit(Images["side_r"],x+w, y+Images["corner_ul"].height, Images["side_d"].width, h-Images["corner_ul"].height)
		
		ika.Video.TileBlit(Images["background"], x+Images["corner_ul"].width, y+Images["corner_ul"].height, w-Images["corner_ul"].width, h-Images["corner_ul"].height)
		
class CustomBackgroundWindow(Window):

	
	def __init__(self, file, bg):
		
		self.Images = { }
		self.Load(file, bg)
	
	def Load(self, file, bg):
		
		#Corners
		
		for x in ["ur", "ul", "dr", "dl"]:
			self.Images["corner_"+x] = ika.Image("images\\"+file+"_corner_"+x+".png")
		
		#Sides
		for x in ["u", "d", "l", "r"]:
			self.Images["side_"+x] = ika.Image("images\\"+file+"_side_"+x+".png")
			
		self.Images["background"] = ika.Image("images\\"+bg+".png")

"""
#Basic Window Test

import manager

test = Window("wtest")
w = 16
h = 16

def TestRender():
	global w,h
	
	test.Render(5,5,w,h)
	
	w += .005
	h += .005

manager.RenderList.append( TestRender )
"""