import ika
import treasure
import engine
from treasure import Treasure
import queue
import transition

class Map:
	
	def __init__(self,map,y,x=-1):
		
		self.Map = map
		self.x = x
		self.y = y



Areas = { 
			"1": [Map("1-1",43),Map("1-2",43)],
			"2": [Map("2-1",33), Map("2-2",33)],
			"c1": [Map("c1-1",38,x=11), Map("c1-2",28,x=25), Map("c1-3", 28, x=33), Map("c1-4", 38, x=10) ],
			"c2": [Map("c2-1",28,x=20),Map("c2-2",28,x=20),Map("c2-3",13,x=48),Map("c2-4",28,x=15)]
		}
AreaIndex = { }
TreasureList = {}
CaveList = {}

CurrentArea = 0

TreasureTotal = 0
CaveTotal = 0

TreasureLimit = 9999999
CaveLimit = 9999999

TreasureMin = 3
TreasureMax = 6
CaveMin = 1
CaveMax = 3

OutsideX = -1
OutsideY = -1

def GetAreaMap(area):
	
	return AreaIndex[area]

def WarpToXY(area,x,y):
	
	m = AreaIndex[area]
	CurrentArea = area
	
	engine.Queue.Add( transition.TransitionTo(ika.RGB(0,0,0,0) ) )
	engine.Queue.Add( queue.Function(engine.ChangeMap, ("maps\\"+m.Map+".ika-map", x, y,"Down")) )
	engine.Queue.Add( queue.Function ( SpawnTreasure, area) )
	engine.Queue.Add( queue.Function ( SpawnCaves) )
	engine.Queue.Add( queue.Function( engine.PlayMusic, "Desert") )
	engine.Queue.Add( transition.TransitionFrom(ika.RGB(0,0,0,0) ) )
	engine.Queue.Add( queue.Function(engine.GGetPlayer().UnFreeze))

def WarpRes(area):
	WarpTo(area, trans=0, que=0)

def WarpTo(area,backwards=0,trans=1,que=1):
	
	global OutsideX, OutsideY,CurrentArea
	
	new = 0
	outside = 0
	
	if area in ["1","2","3","4","5"]:
		outside = 1
	else:
		OutsideX = engine.GGetPlayer().Sprite.x/32
		OutsideY = (engine.GGetPlayer().Sprite.y/32)+1	
		
	if not AreaIndex.has_key(area):
		if area in ["1","2","3","4","5"]:
			AreaIndex[area] = Areas[area][ika.Random(0,len(Areas[area]))]
		else:
			AreaIndex[area] = Areas[area[0:2]][ika.Random(0,len(Areas[area[0:2]]))]

		new = 1
	
	m = AreaIndex[area]
	CurrentArea = area
	
	x = m.x
	if x == -1:
		x = engine.GGetPlayer().Sprite.x/32
	
	y = m.y
	dir = "Up"
	if backwards == 1:
		y = 1
		dir = "Down"
	
	if que:
	
		if trans:
			engine.Queue.Add( transition.TransitionTo(ika.RGB(0,0,0,0) ) )
		engine.Queue.Add( queue.Function(engine.ChangeMap, ("maps\\"+m.Map+".ika-map", x, y,dir)) )
		
		if outside:
			engine.Queue.Add( queue.Function( engine.PlayMusic, "Desert") ,0)
		else:
			engine.Queue.Add( queue.Function( engine.PlayMusic, "Cave") ,0)
		
		
		engine.Queue.Add( queue.Function ( SpawnTreasure, area) )
		if outside:
			engine.Queue.Add( queue.Function ( SpawnCaves) )

		
		if trans:
			engine.Queue.Add( transition.TransitionFrom(ika.RGB(0,0,0,0) ),0 )
			
			
			
		engine.Queue.Add( queue.Function(engine.GGetPlayer().UnFreeze))
	else:
		engine.ChangeMap(("maps\\"+m.Map+".ika-map", x, y,dir))
		SpawnTreasure(area)
		SpawnCaves()
		engine.GGetPlayer().UnFreeze()
	

def FindCave(x,y):

	if CurrentArea[0] == "c":
		return None

	for t in CaveList[CurrentArea]:
		if t.x == x and t.y == y:
			return t
			
	return None

def FindChest(x,y):
	
	for t in TreasureList[CurrentArea]:
		if t.x == x and t.y == y:
			return t
			
	return None

def SpawnTreasure(area):
	
	global TreasureTotal, TreasureList, CurrentArea
	CurrentArea = area

	if area == "1" or area == "2":
		TreasureMin = 3
		TreasureMax = 7
	elif area[0:2]  == "c1" or area[0:2]  == "c2":
		TreasureMin = 2
		TreasureMax = 4
	
	List = []
	TreasureTiles = [84,85,86,87]
	
	for x in range(ika.Map.width/32):
		for y in range(ika.Map.height/32):
			if ika.Map.GetTile(x,y,3) in TreasureTiles:
				List.append((x,y,ika.Map.GetTile(x,y,3)-84))
				ika.Map.SetTile(x,y,3,68)	
	
	if not TreasureList.has_key(area):
		TreasureList[area] = []
		
		Amount = ika.Random(TreasureMin,TreasureMax)			
		while Amount+TreasureTotal > TreasureLimit:	
			Amount = ika.Random(0,TreasureMax)
			
		TreasureTotal += Amount
		
		while Amount > 0 and len(List) > 0:
			n = ika.Random(0,len(List))
			
			#Add treasure chest N
			TreasureList[area].append(Treasure(List[n][0],List[n][1],List[n][2],area))
			
			List.pop(n)
			Amount -= 1

	for x in TreasureList[area]:
		x.UpdateTile()
			

def SpawnCaves():
	
	global CaveTotal, CaveList
	
	CaveTiles = [20]
	List = []
	n = 1
	
	for x in range(ika.Map.width/32):
		for y in range(ika.Map.height/32):
			if ika.Map.GetTile(x,y,3) in CaveTiles:
				List.append((x,y,n))
				ika.Map.SetTile(x,y,3,68)
				n += 1
	area = CurrentArea
	if not CaveList.has_key(area):
		CaveList[area] = []

		Amount = ika.Random(CaveMin,CaveMax)			
		while Amount+CaveTotal > CaveLimit:	
			Amount = ika.Random(0,CaveMax)
			
		if Amount > len(List):
			Amount = len(List)
			
		CaveTotal += Amount
		
		Amount = 2
		
		while Amount > 0  and len(List) > 0:
			n = ika.Random(0,len(List))
			
			#Add cave N
			CaveList[area].append(Cave(List[n][0], List[n][1], List[n][2]))
			
			List.pop(n)
			Amount -= 1
			
	for c in CaveList[area]:
		ika.Map.SetTile(c.x,c.y,1,68)
		ika.Map.SetTile(c.x,c.y,2,68)
		ika.Map.SetTile(c.x,c.y,3,20)
		
from cave import Cave